{}
{This program converts from DEC state of naotation to roman and vice versa}

program convert_roman;
Uses CRT;
var number_in:integer;

{--------------------------------------}
{writes and deletes a mistake          }
{--------------------------------------}
procedure mistake(str:string;y,x:integer);
{str-text of mistake,y position on the screen,x position on the screen}
begin
    gotoxy(3,2);
    textcolor(4);
    write(str);
    delay(10000);
    gotoxy(3,2);
    textcolor(7);
    write(' ':77);

    gotoxy(x+3,y);
end;



{------------------------------------------------------------}
{pressed key is enter                                        }
{------------------------------------------------------------}
function key_enter(position,y:integer):boolean;
{position - quantity of inserted symbols, y position on the screen}
begin
  if position>=1 then
    key_enter:=true
  else
  begin
    mistake('Please, insert number',y,position);
    key_enter:=false;
  end;

end;


{------------------------------------------------------------}
{pressed key is backspace                                    }
{------------------------------------------------------------}
function backspace(var str_in:string;var position:integer;y:integer):string;
{str_in - already inserted string, position - quantity of inserted symbols,
  y position on the screen}
begin
  if str_in<>'' then
  begin
    gotoxy(3,y);
    delete(str_in,position,1);
    write(' ':10);
    gotoxy(3,y);
    write(str_in);
    position:=position-1;
    backspace:=str_in;
  end;
end;

{------------------------------------------------------------}
{insert number for converting                                }
{------------------------------------------------------------}
function insert:string;
var str_in:string;    {string, that is already inserted}
    enter:char;       {key, that is pressed}
    flag:boolean;
    position:integer; {position - quantity of inserted symbols}

begin
  gotoxy(3,3);
  writeln('In what numeration will be number you want to insert?');
  gotoxy(3,4);
  writeln('0 - decimal numbering');
  gotoxy(3,5);
  writeln('1 - roman numbering');
  gotoxy(3,7);

  flag:=false;
  str_in:='';
  position:=0;

  repeat
    enter:=readkey
  until (enter=#48) or (enter=#49);
  write(enter);
  gotoxy(3,11);
  write('Insert the number you want to convert');
  gotoxy(3,12);

  if enter=#48 then                       {enter = '0' - DEC}
  begin
    repeat
    begin
      enter:=readkey;
      case enter of
        #48..#57:
        begin
          if position<=3 then
          begin
            position:=position+1;
            str_in:=concat(str_in,enter);
            write(enter);
          end;
        end;
        #8:
          str_in:=backspace(str_in,position,12);
        #13:
          flag:=key_enter(position,12);
      end;
    end;
    until flag = true;

  end

  else if enter=#49 then             {enter='1' - roman}

  begin
    repeat
    begin
      enter:=upcase(readkey);

      case enter of                  {I,V,X,L,C,D,M}
        #73,#86,#88,#76,#67,#68,#77:
        begin
          if position<=8 then
          begin
            position:=position+1;
            str_in:=concat(str_in,enter);
            write(enter);
          end;
        end;
        #8:
          str_in:=backspace(str_in,position,12);
        #13:
          flag:=key_enter(position,12);
      end;
    end;
    until flag = true;
  end;


  insert:=str_in;
end;

{------------------------------------------------------------}
{converting letter to number                                 }
{------------------------------------------------------------}
function Letter2Number(letter:char):integer;
{letter - letter to convert}
var i:integer;     {counter}
begin
  case ord(upcase(letter)) of
    73: i:=1;    {I}
    86: i:=5;    {V}
    88: i:=10;   {X}
    76: i:=50;   {L}
    67: i:=100;  {C}
    68: i:=500;  {D}
    77: i:=1000; {M}
  end;

  Letter2Number:=i;

end;

{------------------------------------------------------------}
{converting from DEC to roman scale of notation              }
{------------------------------------------------------------}
function convert_dec(str_in:string):integer;
var position,n_out,n1,n2:integer;
{n..-numbers}
begin
  position:=1;
  n_out:=0;
  n1:=0;
  n2:=0;
  repeat
  begin
    n1:=Letter2Number(str_in[position]);
    if position<>length(str_in) then
      n2:=Letter2Number(str_in[position+1])
    else
      n2:=0;

    if n1>=n2 then
    begin
      n_out:=n_out+n1;
      position:=position+1;
    end
    else
    begin
      n_out:=n_out+n2-n1;
      position:=position+2;
    end;

  end;
  until position=length(str_in)+1;

  convert_dec:=n_out;
end;

{------------------------------------------------------------}
{involution                                                  }
{------------------------------------------------------------}
function involution(power:integer):integer;
var i,n:integer; {i - counter, n - number in 'power' power}
begin
  n:=1;
  for i:=1 to power-1 do
    n:=n*10;
  involution:=n;
end;

{------------------------------------------------------------}
{converting digit from DEC to Roman scale of notation        }
{------------------------------------------------------------}
function digit2Rom(factor:integer;var str_out:string;S,S4,S5,S6,S9:string):string;
{example: S=I,S4=IV,S5=V,S6=VI,S9=IX}
var i:integer;   {counter}
begin
  case factor of
    1..3: for i:=1 to factor do str_out:=concat(str_out,S);
    6..8:
      begin
        str_out:=concat(str_out,S5);
        for i:=1 to factor-5 do str_out:=concat(str_out,S);
      end;
    4: str_out:=concat(str_out,S4);
    5: str_out:=concat(str_out,S5);
    6: str_out:=concat(str_out,S6);
    9: str_out:=concat(str_out,S9);
  end;
  digit2Rom:=str_out;
end;

{------------------------------------------------------------}
{converting from DEC to roman scale of notation              }
{------------------------------------------------------------}
function convert_rom(str_in:string):string;      {max str_in is 3999}
var position,power,length_,i,factor,code:integer;
    str_out:string;
begin
   length_:=length(str_in);
   position:=1;
   str_out:='';

   repeat
   begin
     val(str_in[position],factor,code);
     power:=involution(length_);

     case power of
       1000: for i:=1 to factor do str_out:=concat(str_out,'M');
       100: str_out:=digit2Rom(factor,str_out,'C','CD','D','DC','CM');
       10: str_out:=digit2Rom(factor,str_out,'X','XL','L','LX','XC');
       1: str_out:=digit2Rom(factor,str_out,'I','IV','V','VI','IX');
     end;
     position:=position+1;
     length_:=length_-1;
   end;
   until length_ = 0;

   convert_rom:=str_out;
end;

{--------------------------------------}
{draw lines on the screen              }
{--------------------------------------}
procedure draw_screen;
var i:integer;       {counter}
begin
    clrscr;
    for i:=1 to 79 do
    begin
      gotoxy(i,1);
      write('*');
      gotoxy(i,9);
      write('*');
      gotoxy(i,17);
      write('*');
      gotoxy(i,24);
      write('*');
    end;

    for i:=1 to 25 do
    begin
      gotoxy(1,i);
      write('*');
      gotoxy(80,i);
      write('*');
    end;
end;


{============================================================}
var string1,string2,number_out:string; {2 subsidiary strings}
    code,i,n1,n2:integer;    {n1,n2 - 2 subsidiary numbers}
    flag:boolean;

begin
  repeat
  begin
    clrscr;
    draw_screen;
    flag:=true;
    string1:=insert;
    val(string1,i,code);
    if code = 0 then
    begin
      val(string1,n1,code);
      number_out:=convert_rom(string1);
      str(convert_dec(number_out),string2);
    end
    else
    begin
      str(convert_dec(string1),number_out);
      val(number_out,n2,code);
      string2:=convert_rom(number_out);
    end;
    if (string1<>string2) or (n1>=4000) or (n2>=4000) then flag:=false;
  end;
  until flag=true;

  gotoxy(3,19);
  write('The result is: ');
  gotoxy(3,20);
  write(number_out);
  readln;
end.


